# coding: utf-8

"""
    SciCat backend API

    This is the API for the SciCat Backend

    The version of the OpenAPI document: api/v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateJobDto(BaseModel):
    """
    CreateJobDto
    """ # noqa: E501
    type: StrictStr = Field(description="Valid job type as defined in configuration.")
    job_params: Dict[str, Any] = Field(description="Job's parameters as defined by job template in configuration.", alias="jobParams")
    owner_user: Optional[StrictStr] = Field(default=None, description="User that this job belongs to. Applicable only if requesting user has adequate permissions level.", alias="ownerUser")
    owner_group: Optional[StrictStr] = Field(default=None, description="Group that this job belongs to. Applicable only if requesting user has adequate permissions level.", alias="ownerGroup")
    contact_email: Optional[StrictStr] = Field(default=None, description="Email to contact regarding this job. If the job is submitted anonymously, an email has to be provided.", alias="contactEmail")
    __properties: ClassVar[List[str]] = ["type", "jobParams", "ownerUser", "ownerGroup", "contactEmail"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateJobDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateJobDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "jobParams": obj.get("jobParams"),
            "ownerUser": obj.get("ownerUser"),
            "ownerGroup": obj.get("ownerGroup"),
            "contactEmail": obj.get("contactEmail")
        })
        return _obj


